Multi Series in JavaScript

Using ApexCharts with JavaScript

This Multi Series example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
var options = {
  series: [
    {
      name: 'Frontend',
      data: [
        {
          x: 'Design',
          y: [
            new Date('2024-03-05').getTime(),
            new Date('2024-03-08').getTime(),
          ],
        },
        {
          x: 'Code',
          y: [
            new Date('2024-03-08').getTime(),
            new Date('2024-03-11').getTime(),
          ],
        },
        {
          x: 'Test',
          y: [
            new Date('2024-03-11').getTime(),
            new Date('2024-03-16').getTime(),
          ],
        },
      ],
    },
    {
      name: 'Backend',
      data: [
        {
          x: 'Design',
          y: [
            new Date('2024-03-02').getTime(),
            new Date('2024-03-05').getTime(),
          ],
        },
        {
          x: 'Code',
          y: [
            new Date('2024-03-06').getTime(),
            new Date('2024-03-09').getTime(),
          ],
        },
        {
          x: 'Test',
          y: [
            new Date('2024-03-10').getTime(),
            new Date('2024-03-19').getTime(),
          ],
        },
      ],
    },
  ],
  chart: {
    height: 350,
    type: 'rangeBar',
  },
  title: {
    text: 'Frontend vs Backend Schedule',
  },
  plotOptions: {
    bar: {
      borderRadius: 10,
      horizontal: true,
    },
  },
  dataLabels: {
    enabled: true,
    formatter: function (val) {
      var diff = Math.round((val[1] - val[0]) / (1000 * 60 * 60 * 24))
      return diff + (diff > 1 ? ' days' : ' day')
    },
  },
  fill: {
    type: 'gradient',
    gradient: {
      shade: 'light',
      type: 'vertical',
      shadeIntensity: 0.25,
      gradientToColors: undefined,
      inverseColors: true,
      opacityFrom: 1,
      opacityTo: 1,
      stops: [50, 0, 100, 100],
    },
  },
  xaxis: {
    type: 'datetime',
  },
  legend: {
    position: 'top',
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Multi Series in Vue

Using ApexCharts with Vue

This Multi Series example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="rangeBar"
        height="350"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          name: 'Frontend',
          data: [
            {
              x: 'Design',
              y: [
                new Date('2024-03-05').getTime(),
                new Date('2024-03-08').getTime(),
              ],
            },
            {
              x: 'Code',
              y: [
                new Date('2024-03-08').getTime(),
                new Date('2024-03-11').getTime(),
              ],
            },
            {
              x: 'Test',
              y: [
                new Date('2024-03-11').getTime(),
                new Date('2024-03-16').getTime(),
              ],
            },
          ],
        },
        {
          name: 'Backend',
          data: [
            {
              x: 'Design',
              y: [
                new Date('2024-03-02').getTime(),
                new Date('2024-03-05').getTime(),
              ],
            },
            {
              x: 'Code',
              y: [
                new Date('2024-03-06').getTime(),
                new Date('2024-03-09').getTime(),
              ],
            },
            {
              x: 'Test',
              y: [
                new Date('2024-03-10').getTime(),
                new Date('2024-03-19').getTime(),
              ],
            },
          ],
        },
      ],
      chartOptions: {
        chart: {
          height: 350,
          type: 'rangeBar',
        },
        title: {
          text: 'Frontend vs Backend Schedule',
        },
        plotOptions: {
          bar: {
            borderRadius: 10,
            horizontal: true,
          },
        },
        dataLabels: {
          enabled: true,
          formatter: function (val) {
            var diff = Math.round((val[1] - val[0]) / (1000 * 60 * 60 * 24))
            return diff + (diff > 1 ? ' days' : ' day')
          },
        },
        fill: {
          type: 'gradient',
          gradient: {
            shade: 'light',
            type: 'vertical',
            shadeIntensity: 0.25,
            gradientToColors: undefined,
            inverseColors: true,
            opacityFrom: 1,
            opacityTo: 1,
            stops: [50, 0, 100, 100],
          },
        },
        xaxis: {
          type: 'datetime',
        },
        legend: {
          position: 'top',
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 650px;
  margin: 35px auto;
}
</style>

Multi Series in React

Using ApexCharts with React

This Multi Series example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        name: 'Frontend',
        data: [
          {
            x: 'Design',
            y: [
              new Date('2024-03-05').getTime(),
              new Date('2024-03-08').getTime(),
            ],
          },
          {
            x: 'Code',
            y: [
              new Date('2024-03-08').getTime(),
              new Date('2024-03-11').getTime(),
            ],
          },
          {
            x: 'Test',
            y: [
              new Date('2024-03-11').getTime(),
              new Date('2024-03-16').getTime(),
            ],
          },
        ],
      },
      {
        name: 'Backend',
        data: [
          {
            x: 'Design',
            y: [
              new Date('2024-03-02').getTime(),
              new Date('2024-03-05').getTime(),
            ],
          },
          {
            x: 'Code',
            y: [
              new Date('2024-03-06').getTime(),
              new Date('2024-03-09').getTime(),
            ],
          },
          {
            x: 'Test',
            y: [
              new Date('2024-03-10').getTime(),
              new Date('2024-03-19').getTime(),
            ],
          },
        ],
      },
    ],
    options: {
      chart: {
        height: 350,
        type: 'rangeBar',
      },
      title: {
        text: 'Frontend vs Backend Schedule',
      },
      plotOptions: {
        bar: {
          borderRadius: 10,
          horizontal: true,
        },
      },
      dataLabels: {
        enabled: true,
        formatter: function (val) {
          var diff = Math.round((val[1] - val[0]) / (1000 * 60 * 60 * 24))
          return diff + (diff > 1 ? ' days' : ' day')
        },
      },
      fill: {
        type: 'gradient',
        gradient: {
          shade: 'light',
          type: 'vertical',
          shadeIntensity: 0.25,
          gradientToColors: undefined,
          inverseColors: true,
          opacityFrom: 1,
          opacityTo: 1,
          stops: [50, 0, 100, 100],
        },
      },
      xaxis: {
        type: 'datetime',
      },
      legend: {
        position: 'top',
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="rangeBar"
          height={350}
        />
      </div>
    </div>
  )
}

export default ApexChart

Multi Series in Angular

Using ApexCharts with Angular

This Multi Series example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              name: 'Frontend',
              data: [
                {
                  x: 'Design',
                  y: [
                    new Date('2024-03-05').getTime(),
                    new Date('2024-03-08').getTime(),
                  ],
                },
                {
                  x: 'Code',
                  y: [
                    new Date('2024-03-08').getTime(),
                    new Date('2024-03-11').getTime(),
                  ],
                },
                {
                  x: 'Test',
                  y: [
                    new Date('2024-03-11').getTime(),
                    new Date('2024-03-16').getTime(),
                  ],
                },
              ],
            },
            {
              name: 'Backend',
              data: [
                {
                  x: 'Design',
                  y: [
                    new Date('2024-03-02').getTime(),
                    new Date('2024-03-05').getTime(),
                  ],
                },
                {
                  x: 'Code',
                  y: [
                    new Date('2024-03-06').getTime(),
                    new Date('2024-03-09').getTime(),
                  ],
                },
                {
                  x: 'Test',
                  y: [
                    new Date('2024-03-10').getTime(),
                    new Date('2024-03-19').getTime(),
                  ],
                },
              ],
            },
          ],
          chart: {
            height: 350,
            type: 'rangeBar',
          },
          title: {
            text: 'Frontend vs Backend Schedule',
          },
          plotOptions: {
            bar: {
              borderRadius: 10,
              horizontal: true,
            },
          },
          dataLabels: {
            enabled: true,
            formatter: (val) => {
              var diff = Math.round((val[1] - val[0]) / (1000 * 60 * 60 * 24))
              return diff + (diff > 1 ? ' days' : ' day')
            },
          },
          fill: {
            type: 'gradient',
            gradient: {
              shade: 'light',
              type: 'vertical',
              shadeIntensity: 0.25,
              gradientToColors: undefined,
              inverseColors: true,
              opacityFrom: 1,
              opacityTo: 1,
              stops: [50, 0, 100, 100],
            },
          },
          xaxis: {
            type: 'datetime',
          },
          legend: {
            position: 'top',
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}